searchData={"items":[{"type":"module","title":"AlibabaCloudKit","doc":"A kit for Alibaba Cloud or Aliyun.\n\n> This package is built by following my proposal -\n> [Ship utilities for building platform SDKs](https://github.com/cozy-elixir/proposals/blob/main/ship-utilities-for-building-platform-sdks.md).","ref":"AlibabaCloudKit.html"},{"type":"module","title":"API styles - AlibabaCloudKit","doc":"For a variety of reasons, Alibaba Cloud involves several different API styles:\n\n* RPC\n* ROA\n* OSS\n\nThese different API styles are supported by different modules:\n\n* `AlibabaCloudKit.RPC`\n* `AlibabaCloudKit.ROA`\n* `AlibabaCloudKit.OSS`\n\n> Q: Which style should I use?\n>\n> A: You should check the API style by yourself. See next section for more.","ref":"AlibabaCloudKit.html#module-api-styles"},{"type":"module","title":"Check API style - AlibabaCloudKit","doc":"1. Visit [OpenAPI Explorer](https://next.api.alibabacloud.com/).\n2. Search the API you wanna use.\n3. Check the metadata, and the the metadata should like this:\n\n```json\n{\n  \"version\": \"1.0\",\n  \"info\": {\n     \"version\": \"2014-05-26\",\n     \"style\": \"RPC\",  # <- This is the API style.\n     \"product\": \"Ecs\"\n  },\n  // ...\n}\n```","ref":"AlibabaCloudKit.html#module-check-api-style"},{"type":"module","title":"Authentication - AlibabaCloudKit","doc":"Different styles of API use different signature mechanisms to authenticate an\nAPI request.\n\nThe `AlibabaCloudKit.*` modules will try their best to provide relevant helpers.","ref":"AlibabaCloudKit.html#module-authentication"},{"type":"module","title":"Authorization - AlibabaCloudKit","doc":"Before calling any API, please make sure that the required permission is granted.","ref":"AlibabaCloudKit.html#module-authorization"},{"type":"module","title":"About endpoints - AlibabaCloudKit","doc":"In official docs, the term *endpoint* refers to different things:\n\n* sometimes, it refers to a host, such as `ecs.us-west-1.aliyuncs.com`.\n* sometimes, it refers to a URL, such as `https://ecs.use-west-1.aliyuncs.com`.\n\nThis kind of inconsistency is annoying.\n\n`AlibabaCloudKit` will **always** use the term *endpoint* to refer to a base URL:\n\n     :// /","ref":"AlibabaCloudKit.html#module-about-endpoints"},{"type":"module","title":"Public endpoints - AlibabaCloudKit","doc":"* centralized deployments: ` :// .aliyuncs.com/`\n* multi-region deployments: ` :// . .aliyuncs.com/`","ref":"AlibabaCloudKit.html#module-public-endpoints"},{"type":"module","title":"private endpoints (aka VPC endpoints) - AlibabaCloudKit","doc":"Private endpoints are also known as VPC endpoints.\n\n* centralized deployments: ` :// .vpc-proxy.aliyuncs.com/`\n* multi-region deployments: ` :// -vpc. .aliyuncs.com/`","ref":"AlibabaCloudKit.html#module-private-endpoints-aka-vpc-endpoints"},{"type":"module","title":"Public endpoints vs. Private endpoints - AlibabaCloudKit","doc":"Public endpoints consume public network traffic.\n\nPrivate endpoints don't consume public network traffic. In addition, they provide higher network\nspeed, and higher level secure protection.\n\nPersonally, I recommend using private endpoints as much as possible.","ref":"AlibabaCloudKit.html#module-public-endpoints-vs-private-endpoints"},{"type":"module","title":"AlibabaCloudKit.OSS","doc":"A kit for OSS style API.\n\nRead more at:\n\n  * [Object Storage Service > Developer Reference > Developer Guide > Use the RESTful API to initiate requests](https://www.alibabacloud.com/help/en/oss/developer-reference/use-the-restful-api-to-initiate-requests/)\n  * [对象存储 > 开发参考 > 开发指南 > 使用 REST API 发起请求](https://help.aliyun.com/zh/oss/developer-reference/use-the-restful-api-to-initiate-requests/)","ref":"AlibabaCloudKit.OSS.html"},{"type":"module","title":"The base URL - AlibabaCloudKit.OSS","doc":"Following formats can be used:\n\n  * region URL, such as `https://oss-us-west-1.aliyuncs.com`.\n  * virtual-hosted style URL, such as `https://example-bucket.oss-us-west-1.aliyuncs.com`.\n  * custom domain name, such as `https://www.example.com`.\n  * ...","ref":"AlibabaCloudKit.OSS.html#module-the-base-url"},{"type":"module","title":"Adding signature - AlibabaCloudKit.OSS","doc":"This implementation has built-in OSS4 signature support, and it's controlled\nby the `:sign_type` option:\n\n  * `:header` - add signature to the headers of a request.\n  * `:query` - add signature to the query of a request.\n\n> V1 signature is not supported.","ref":"AlibabaCloudKit.OSS.html#module-adding-signature"},{"type":"module","title":"Required headers - AlibabaCloudKit.OSS","doc":"All necessary headers of requests will be generated automatically. You don't\nhave to specifically set them, unless you want to customize it.","ref":"AlibabaCloudKit.OSS.html#module-required-headers"},{"type":"module","title":"Examples - AlibabaCloudKit.OSS","doc":"","ref":"AlibabaCloudKit.OSS.html#module-examples"},{"type":"module","title":"Build and sign a request for `ListBucktets` operation - AlibabaCloudKit.OSS","doc":"request = HTTPSpec.Request.new!(\n      method: :get,\n      scheme: :https,\n      host: \"oss-us-west-1.aliyuncs.com\",\n      port: 443,\n      path: \"/\"\n    )\n\n    opts = [\n      access_key_id: \"...\",\n      access_key_secret: \"...\",\n      region: \"oss-us-west-1\",\n      sign_type: :header\n    ]\n\n\n    AlibabaCloudKit.OSS.sign_request!(request, opts)","ref":"AlibabaCloudKit.OSS.html#module-build-and-sign-a-request-for-listbucktets-operation"},{"type":"module","title":"Build a pre-signed url for `GetObject` operation - AlibabaCloudKit.OSS","doc":"request = HTTPSpec.Request.new!(\n      method: :get,\n      scheme: :https,\n      host: \"example-bucket.oss-us-west-1.aliyuncs.com\",\n      port: 443,\n      path: \"/example-object\",\n      headers: [\n        {\"x-oss-expires\", \"900\"}\n      ]\n    )\n\n    opts = [\n      access_key_id: \"...\",\n      access_key_secret: \"...\",\n      region: \"oss-us-west-1\",\n      bucket: \"example-bucket\",\n      sign_type: :query\n    ]\n\n    request\n    |> AlibabaCloudKit.OSS.sign_request!(opts)\n    |> HTTPSpec.Request.build_url()","ref":"AlibabaCloudKit.OSS.html#module-build-a-pre-signed-url-for-getobject-operation"},{"type":"function","title":"AlibabaCloudKit.OSS.sign_request!/2","doc":"Signs a request with OSS4 signature.","ref":"AlibabaCloudKit.OSS.html#sign_request!/2"},{"type":"type","title":"AlibabaCloudKit.OSS.access_key_id/0","doc":"","ref":"AlibabaCloudKit.OSS.html#t:access_key_id/0"},{"type":"type","title":"AlibabaCloudKit.OSS.access_key_secret/0","doc":"","ref":"AlibabaCloudKit.OSS.html#t:access_key_secret/0"},{"type":"type","title":"AlibabaCloudKit.OSS.at/0","doc":"","ref":"AlibabaCloudKit.OSS.html#t:at/0"},{"type":"type","title":"AlibabaCloudKit.OSS.bucket/0","doc":"","ref":"AlibabaCloudKit.OSS.html#t:bucket/0"},{"type":"type","title":"AlibabaCloudKit.OSS.region/0","doc":"","ref":"AlibabaCloudKit.OSS.html#t:region/0"},{"type":"type","title":"AlibabaCloudKit.OSS.sign_opt/0","doc":"","ref":"AlibabaCloudKit.OSS.html#t:sign_opt/0"},{"type":"type","title":"AlibabaCloudKit.OSS.sign_opts/0","doc":"","ref":"AlibabaCloudKit.OSS.html#t:sign_opts/0"},{"type":"type","title":"AlibabaCloudKit.OSS.sign_type/0","doc":"","ref":"AlibabaCloudKit.OSS.html#t:sign_type/0"},{"type":"module","title":"AlibabaCloudKit.OSS.Object","doc":"Provides object related helpers.","ref":"AlibabaCloudKit.OSS.Object.html"},{"type":"function","title":"AlibabaCloudKit.OSS.Object.presign_post_object/3","doc":"Presigns a `PostObject` operation and returns the necessary form data when\nexecuting the `PostObject` operation.\n\nRead more at:\n\n  * [PostObject](https://www.alibabacloud.com/help/en/oss/developer-reference/postobject/)\n  * [PostObject (zh-Hans)](https://help.aliyun.com/zh/oss/developer-reference/postobject/)","ref":"AlibabaCloudKit.OSS.Object.html#presign_post_object/3"},{"type":"function","title":"Adding signature - AlibabaCloudKit.OSS.Object.presign_post_object/3","doc":"This implementation has built-in OSS4 signature support.\n\n> V1 signature is not supported.","ref":"AlibabaCloudKit.OSS.Object.html#presign_post_object/3-adding-signature"},{"type":"function","title":"Examples - AlibabaCloudKit.OSS.Object.presign_post_object/3","doc":"region = \"oss-us-west-1\"\n    bucket = \"example-bucket\"\n\n    key = \"lenna.png\"\n    acl = \"private\"\n    max_size_in_bytes = 1024 * 1024 * 5\n\n    conditions = [\n      [\"eq\", \"$key\", key],\n      [\"eq\", \"$x-oss-object-acl\", acl],\n      [\"content-length-range\", 1, max_size_in_bytes]\n    ]\n\n    seconds_to_expire = 3600\n\n    opts = [\n      access_key_id: \"...\",\n      access_key_secret: \"...\",\n      region: region,\n      bucket: bucket\n    ]\n\n    %{\n      policy: policy,\n      \"x-oss-signature-version\": x_oss_signature_version,\n      \"x-oss-credential\": x_oss_credential,\n      \"x-oss-date\": x_oss_date,\n      \"x-oss-signature\": x_oss_signature,\n    } = presign_post_object(conditions, seconds_to_expire, opts)\n\nTo use the returned data, you should built a form with multipart data, and send it:\n\n    alias Tesla.Multipart\n\n    url = \"https://#{bucket}.#{region}.aliyuncs.com\"\n\n    multipart =\n      Multipart.new()\n      |> Multipart.add_field(\"key\", key)\n      |> Multipart.add_field(\"x-oss-object-acl\", acl)\n      |> Multipart.add_field(\"policy\", policy)\n      |> Multipart.add_field(\"x-oss-credential\", x_oss_credential)\n      |> Multipart.add_field(\"x-oss-date\", x_oss_date)\n      |> Multipart.add_field(\"x-oss-signature-version\", x_oss_signature_version)\n      |> Multipart.add_field(\"x-oss-signature\", x_oss_signature)\n      |> Multipart.add_file_content(binary_of_file, \"lenna.png\")\n\n    {:ok, %{status: 204}} = Tesla.post(url, multipart)","ref":"AlibabaCloudKit.OSS.Object.html#presign_post_object/3-examples"},{"type":"type","title":"AlibabaCloudKit.OSS.Object.access_key_id/0","doc":"","ref":"AlibabaCloudKit.OSS.Object.html#t:access_key_id/0"},{"type":"type","title":"AlibabaCloudKit.OSS.Object.access_key_secret/0","doc":"","ref":"AlibabaCloudKit.OSS.Object.html#t:access_key_secret/0"},{"type":"type","title":"AlibabaCloudKit.OSS.Object.at/0","doc":"","ref":"AlibabaCloudKit.OSS.Object.html#t:at/0"},{"type":"type","title":"AlibabaCloudKit.OSS.Object.bucket/0","doc":"","ref":"AlibabaCloudKit.OSS.Object.html#t:bucket/0"},{"type":"type","title":"AlibabaCloudKit.OSS.Object.region/0","doc":"","ref":"AlibabaCloudKit.OSS.Object.html#t:region/0"},{"type":"type","title":"AlibabaCloudKit.OSS.Object.sign_opt/0","doc":"","ref":"AlibabaCloudKit.OSS.Object.html#t:sign_opt/0"},{"type":"type","title":"AlibabaCloudKit.OSS.Object.sign_opts/0","doc":"","ref":"AlibabaCloudKit.OSS.Object.html#t:sign_opts/0"},{"type":"module","title":"AlibabaCloudKit.ROA","doc":"A kit for ROA style API.\n\n> ROA is a resource-oriented architectural style and an extension of\n> the REST style.\n\nAPIs in the RPC style include:\n\n  * Application Real-Time Monitoring Service (ARMS)\n  * Batch Compute, Container Service for Kubernetes (ACK)\n  * Elasticsearch\n  * ...","ref":"AlibabaCloudKit.ROA.html"},{"type":"module","title":"AlibabaCloudKit.RPC","doc":"A kit for RPC style API.\n\nAPIs in the RPC style include:\n\n  * Elastic Compute Service (ECS)\n  * Content Delivery Network (CDN)\n  * ApsaraDB RDS\n  * ...\n\nRead more at:\n\n  * [Alibaba Cloud SDK > Product Overview > Request syntax and signature method](https://www.alibabacloud.com/help/en/sdk/product-overview/request-structure-and-signature/)\n  * [阿里云 SDK > 产品概述 > 请求结构和签名机制](https://help.aliyun.com/zh/sdk/product-overview/request-structure-and-signature/)","ref":"AlibabaCloudKit.RPC.html"},{"type":"module","title":"Examples - AlibabaCloudKit.RPC","doc":"","ref":"AlibabaCloudKit.RPC.html#module-examples"},{"type":"module","title":"Build and sign a GET request - AlibabaCloudKit.RPC","doc":"request = HTTPSpec.Request.new!(\n      method: :get,\n      scheme: :https,\n      host: \"ecs-us-west-1.aliyuncs.com\",\n      port: 443,\n      path: \"/\",\n      query: URI.encode_query(%{\"RegionId\" => \"us-west-1\"}, :www_form),\n      headers: [\n        {\"x-acs-version\", \"2014-05-26\"},\n        {\"x-acs-action\", \"DescribeInstanceStatus\"}\n      ]\n    )\n\n    opts = [\n      access_key_id: \"...\",\n      access_key_secret: \"...\"\n    ]\n\n    AlibabaCloudKit.RPC.sign_request!(request, opts)","ref":"AlibabaCloudKit.RPC.html#module-build-and-sign-a-get-request"},{"type":"module","title":"Build and sign a POST request - AlibabaCloudKit.RPC","doc":"request = HTTPSpec.Request.new!(\n      method: :post,\n      scheme: :https,\n      host: \"ecs-us-west-1.aliyuncs.com\",\n      port: 443,\n      path: \"/\",\n      headers: [\n        {\"content-type\", \"application/x-www-form-urlencoded\"},\n        {\"x-acs-version\", \"2014-05-26\"},\n        {\"x-acs-action\", \"DescribeInstanceStatus\"}\n      ],\n      body: URI.encode_query(%{\"RegionId\" => \"us-west-1\"}, :www_form)\n    )\n\n    opts = [\n      access_key_id: \"...\",\n      access_key_secret: \"...\"\n    ]\n\n    AlibabaCloudKit.RPC.sign_request!(request, opts)","ref":"AlibabaCloudKit.RPC.html#module-build-and-sign-a-post-request"},{"type":"function","title":"AlibabaCloudKit.RPC.sign_request!/2","doc":"Signs a request with ACS3 signature.","ref":"AlibabaCloudKit.RPC.html#sign_request!/2"},{"type":"type","title":"AlibabaCloudKit.RPC.access_key_id/0","doc":"","ref":"AlibabaCloudKit.RPC.html#t:access_key_id/0"},{"type":"type","title":"AlibabaCloudKit.RPC.access_key_secret/0","doc":"","ref":"AlibabaCloudKit.RPC.html#t:access_key_secret/0"},{"type":"type","title":"AlibabaCloudKit.RPC.at/0","doc":"","ref":"AlibabaCloudKit.RPC.html#t:at/0"},{"type":"type","title":"AlibabaCloudKit.RPC.sign_opt/0","doc":"","ref":"AlibabaCloudKit.RPC.html#t:sign_opt/0"},{"type":"type","title":"AlibabaCloudKit.RPC.sign_opts/0","doc":"","ref":"AlibabaCloudKit.RPC.html#t:sign_opts/0"},{"type":"module","title":"AlibabaCloudKit.Signature.ACS3","doc":"A implementation for ACS V3 signature.\n\nRead more at:\n\n  * [Alibaba Cloud SDK > Product Overview > Request syntax and signature method V3](https://www.alibabacloud.com/help/en/sdk/product-overview/v3-request-structure-and-signature)\n  * [阿里云 SDK > 产品概述 > 请求结构和签名机制 > V3 版本请求体 & 签名机制](https://help.aliyun.com/zh/sdk/product-overview/request-structure-and-signature)","ref":"AlibabaCloudKit.Signature.ACS3.html"},{"type":"function","title":"AlibabaCloudKit.Signature.ACS3.sign/2","doc":"","ref":"AlibabaCloudKit.Signature.ACS3.html#sign/2"},{"type":"module","title":"AlibabaCloudKit.Signature.OSS4","doc":"A implementation for OSS V4 signature.\n\nRead more at:\n\n  * [Object Storage Service > Developer Reference > Use the RESTful API to initiate requests](https://www.alibabacloud.com/help/en/oss/developer-reference/use-the-restful-api-to-initiate-requests/)\n  * [对象存储 > 开发参考 > 开发指南 > 使用 REST API 发起请求](https://help.aliyun.com/zh/oss/developer-reference/use-the-restful-api-to-initiate-requests/)","ref":"AlibabaCloudKit.Signature.OSS4.html"},{"type":"function","title":"AlibabaCloudKit.Signature.OSS4.sign/2","doc":"","ref":"AlibabaCloudKit.Signature.OSS4.html#sign/2"},{"type":"extras","title":"AlibabaCloudKit","doc":"# AlibabaCloudKit\n\n[![CI](https://github.com/cozy-elixir/alibaba_cloud_kit/actions/workflows/ci.yml/badge.svg)](https://github.com/cozy-elixir/alibaba_cloud_kit/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/alibaba_cloud_kit.svg)](https://hex.pm/packages/alibaba_cloud_kit)\n\nA kit for Alibaba Cloud or Aliyun.","ref":"readme.html"},{"type":"extras","title":"Notes - AlibabaCloudKit","doc":"This package is still in its early stages, so it may still undergo significant changes, potentially leading to breaking changes.","ref":"readme.html#notes"},{"type":"extras","title":"Installation - AlibabaCloudKit","doc":"Add `:alibaba_cloud_kit` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:alibaba_cloud_kit, \" \"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AlibabaCloudKit","doc":"For more information, see the [documentation](https://hexdocs.pm/alibaba_cloud_kit).","ref":"readme.html#usage"},{"type":"extras","title":"Tests - AlibabaCloudKit","doc":"Run basic tests:\n\n```console\n$ mix test\n```\n\nRun all tests:\n\n```console\n$ export TEST_ACCESS_KEY_ID=...\n$ export TEST_ACCESS_KEY_SECRET=...\n$ export TEST_OSS_REGION=...\n$ export TEST_OSS_BUCKET=...\n\n$ mix test --include external:true\n```","ref":"readme.html#tests"},{"type":"extras","title":"License - AlibabaCloudKit","doc":"[Apache License 2.0](http://www.apache.org/licenses/LICENSE-2.0)","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"Unreleased - Changelog","doc":"- rename this package from `aliyun_open_api` to `alibaba_cloud_kit`.\n- adjust all the code","ref":"changelog.html#unreleased"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}